/*
 * Copyright (c) 2012-2014 Wind River Systems, Inc.
 *
 * SPDX-License-Identifier: Apache-2.0
 */
/*
* typedef
*/
typedef unsigned          char u8_t;
typedef unsigned          short u16_t;
typedef unsigned           int u32_t;

/* 
 * include
 */
#include <zephyr.h>
#include <sys/printk.h>
#include <drivers/spi.h>
#include <drivers/gpio.h>
#include <device.h>
#include <devicetree.h>
#include <kernel.h>

#include <zephyr/types.h>
#include <stddef.h>
#include <string.h>
#include <errno.h>
#include <sys/byteorder.h>

#define spiName "SPI_1"

static const struct spi_config spi_cfg = {
	.operation = SPI_WORD_SET(8) | SPI_TRANSFER_MSB | 
		     SPI_MODE_CPOL | SPI_MODE_CPHA,
	.frequency = 8000000,
	.slave = 1,
};
const struct device * spi_dev;


static u16_t tx_buffer[1] = {0};
	static u16_t rx_buffer[1] = {0};
	
	// tx buf
	const struct spi_buf tx_buf = {
		.buf = tx_buffer,
		.len = sizeof(tx_buffer)
	};
	// spi buf array 
	const struct spi_buf_set tx = {
		.buffers = &tx_buf,
		.count = 1
	};
	// RX buf
	struct spi_buf rx_buf = {
		.buf = rx_buffer,
		.len = sizeof(rx_buffer),
	};
	const struct spi_buf_set rx = {
		.buffers = &rx_buf,
		.count = 1
	};



void main(void){
    //u16_t result[200];
	u8_t err;
	uint64_t stamp;
	uint64_t delta;
	uint64_t stamps;
	uint64_t deltas;
	spi_dev = device_get_binding(spiName);
	// one api calls to init spi
	err = spi_transceive(spi_dev ,&spi_cfg ,&tx ,&rx);
	// round-robin fashion
	stamp = k_uptime_get_32();
	for(int i=0;i<10000;i++){
        err = spi_transceive(spi_dev ,&spi_cfg ,&tx ,&rx);
	}
	delta = k_uptime_delta(&stamp);
	printk("SPI round-robin fashion Use time is:%lld ms \n", delta); // 258ms 
	// one calling

	static u16_t tx_buffer[10000] = {0};
	static u16_t rx_buffer[10000] = {0};
	
	// tx buf
	const struct spi_buf tx_buf = {
		.buf = tx_buffer,
		.len = sizeof(tx_buffer)
	};
	// spi buf array 
	const struct spi_buf_set tx = {
		.buffers = &tx_buf,
		.count = 1
	};
	// RX buf
	struct spi_buf rx_buf = {
		.buf = rx_buffer,
		.len = sizeof(rx_buffer),
	};
	const struct spi_buf_set rx = {
		.buffers = &rx_buf,
		.count = 1
	};

stamps = k_uptime_get_32();
    err = spi_transceive(spi_dev ,&spi_cfg ,&tx ,&rx);
deltas = k_uptime_delta(&stamps);
	printk("SPI one calling fashion Use time is:%lld ms \n", deltas); // 20ms 8MHz

}